<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { MessageBoxType, type MessageBoxOptions } from './MessageBox'

type HTMLButtonRef = InstanceType<typeof HTMLButtonElement>

// using
const { t } = useI18n({
	messages: {
		en: {
			close: "Close",
			ok: "OK",
			cancel: "Cancel",
			yes: "Yes",
			no: "No",
			retry: "Retry",
			info: "Infomation",
			warning: "Warning",
			error: "Error",
			question: "Question",
		},
		th: {
			close: "ปิด",
			ok: "ตกลง",
			cancel: "ยกเลิก",
			yes: "ใช่",
			no: "ไม่ใช่",
			retry: "ลองใหม่",
			info: "ข่าวสาร",
			warning: "แจ้งเตือน",
			error: "เกิดข้อผิดพลาด",
			question: "คำถาม",
		},
	},
})

// states
const defaultOptions = ref(<MessageBoxOptions>{
	caption: "",
	content: "",
	type: MessageBoxType.close,
	alternateFocus: false,
	barrierDismissible: true,
	barrierBackground: '#3339',
	titleBackground: '#000',
	titleColor: '#fff',
	icon: '',
	iconColor: '#000',
	rightIcon: true,
})
const options = ref(<MessageBoxOptions>{
})
const opened = ref(<boolean>false)

// support states
const orderIcon = ref('')
const orderText = ref('')
const timer = ref(<any>null)
const firstKey = ref(<HTMLButtonRef | null>null)
const lastKey = ref(<HTMLButtonRef | null>null)
const closeButton = ref(<HTMLButtonRef | null>null)
const okButton = ref(<HTMLButtonRef | null>null)
const retryButton = ref(<HTMLButtonRef | null>null)
const cancelButton = ref(<HTMLButtonRef | null>null)
const yesButton = ref(<HTMLButtonRef | null>null)
const noButton = ref(<HTMLButtonRef | null>null)

// ----------------------------------------------------------------------

// exposed API
defineExpose({

	/**
	 * Set defaults options, before calling open().
	 */
	setDefaults: function (o: MessageBoxOptions): void {
		defaultOptions.value = { ...o }
		console.log(`MessageBox.defaultOptions: ${JSON.stringify(defaultOptions.value, null, 2)}`)
	},

	/**
	 * Checks if the message box is opened or not.
	 */
	isOpen: function (): boolean {
		return opened.value
	},

	/**
	 * Opens message box.
	 * Return true if the message box is opened successfully.
	 * Otherwise, it is false.
	 */
	open: function (o: MessageBoxOptions): boolean {
		return openThis(o)
	},

	/**
	 * Opens infomation box.
	 */
	info: function (content: string, callback?: (result: boolean) => void): boolean {
		return openThis({
			caption: t('info'),
			content,
			type: MessageBoxType.close,
			alternateFocus: false,
			barrierDismissible: true,
			barrierBackground: '#3939',
			titleBackground: '#388e3c',
			titleColor: '#fff',
			icon: 'info',
			iconColor: '#388e3c',
			callback,
		})
	},

	/**
	 * Opens warning box.
	 */
	warning: function (content: string, callback?: (result: boolean) => void): boolean {
		return openThis({
			caption: t('warning'),
			content,
			type: MessageBoxType.close,
			alternateFocus: false,
			barrierDismissible: false,
			barrierBackground: '#f639',
			titleBackground: '#f57c00',
			titleColor: '#fff',
			icon: 'warning',
			iconColor: '#f57c00',
			callback,
		})
	},

	/**
	 * Opens error box.
	 */
	error: function (content: string, callback?: (result: boolean) => void): boolean {
		return openThis({
			caption: t('error'),
			content,
			type: MessageBoxType.close,
			alternateFocus: false,
			barrierDismissible: false,
			barrierBackground: '#9009',
			titleBackground: '#d32f2f',
			titleColor: '#fff',
			icon: 'error',
			iconColor: '#d32f2f',
			callback,
		})
	},

	/**
	 * Opens question box.
	 */
	question: function (content: string, callback?: (result: boolean) => void): boolean {
		return openThis({
			caption: t('question'),
			content,
			type: MessageBoxType.yesNo,
			alternateFocus: false,
			barrierDismissible: false,
			barrierBackground: '#3699',
			titleBackground: '#1976d2',
			titleColor: '#fff',
			icon: 'help',
			iconColor: '#1976d2',
			callback,
		})
	},

	/**
	 * Closes the message box.
	 */
	close: function (result: boolean): void {
		closeThis(result)
	},

})

// ----------------------------------------------------------------------

function onKeyDownEscape(event: KeyboardEvent): void {
	if (event.key === 'Escape') {
		closeThis(false)
		event.preventDefault()
	}
}

function onKeyDownButton(event: KeyboardEvent): void {
	if (event.key === 'Tab') {
		if (event.shiftKey) {
			if (event.target == firstKey.value) {
				lastKey.value?.focus()
				event.preventDefault()
			}
		}
		else {
			if (event.target == lastKey.value) {
				firstKey.value?.focus()
				event.preventDefault()
			}
		}
	}
}

function shader(): void {
	if (opened.value && options.value.barrierDismissible) {
		closeThis(false)
	}
}

function nl2br(s: string): string {
	return s.replace(/\r\n|\n|\r/gm, '<br/>')
}

function openThis(o: MessageBoxOptions): boolean {
	// checks if it already opened
	if (opened.value) {
		return false
	}

	options.value = { ...defaultOptions.value }
	options.value.caption = o.caption
	options.value.content = nl2br(o.content)
	options.value.type = o.type
	if (typeof o.alternateFocus === 'boolean')
		options.value.alternateFocus = o.alternateFocus
	if (typeof o.barrierDismissible === 'boolean')
		options.value.barrierDismissible = o.barrierDismissible
	if (typeof o.barrierBackground === 'string')
		options.value.barrierBackground = o.barrierBackground
	if (typeof o.titleBackground === 'string')
		options.value.titleBackground = o.titleBackground
	if (typeof o.titleColor === 'string')
		options.value.titleColor = o.titleColor
	if (typeof o.icon === 'string')
		options.value.icon = o.icon
	if (typeof o.iconColor === 'string')
		options.value.iconColor = o.iconColor
	if (typeof o.rightIcon === 'boolean')
		options.value.rightIcon = o.rightIcon
	options.value.callback = o.callback
	opened.value = true
	console.log(`MessageBox.options: ${JSON.stringify(options.value, null, 2)}`)
	window.addEventListener('keydown', onKeyDownEscape)

	if (options.value.rightIcon) {
		orderIcon.value = 'order-2'
		orderText.value = 'order-1'
	}
	else {
		orderIcon.value = 'order-1'
		orderText.value = 'order-2'
	}

	timer.value = setTimeout(() => {
		if (options.value.type === MessageBoxType.close) {
			const button = closeButton.value
			firstKey.value = button
			lastKey.value = button
			button?.focus()
		}
		else if (options.value.type === MessageBoxType.ok) {
			const button = okButton.value
			firstKey.value = button
			lastKey.value = button
			button?.focus()
		}
		else if (options.value.type === MessageBoxType.okCancel) {
			const button = options.value.alternateFocus ? okButton.value : cancelButton.value
			firstKey.value = okButton.value
			lastKey.value = cancelButton.value
			button?.focus()
		}
		else if (options.value.type === MessageBoxType.yesNo) {
			const button = options.value.alternateFocus ? yesButton.value : noButton.value
			firstKey.value = yesButton.value
			lastKey.value = noButton.value
			button?.focus()
		}
		else if (options.value.type === MessageBoxType.retryCancel) {
			const button = options.value.alternateFocus ? retryButton.value : cancelButton.value
			firstKey.value = retryButton.value
			lastKey.value = cancelButton.value
			button?.focus()
		}
	}, 0)

	return true
}

function closeThis(result: boolean): void {
	if (opened.value) {
		clearTimeout(timer.value)
		window.removeEventListener('keydown', onKeyDownEscape)
		opened.value = false
		if (options.value.callback)
			options.value.callback(result)
	}
}
</script>


<style scoped>
#container {
	position: fixed;
	width: 100%;
	height: 100%;
	left: 0px;
	top: 0px;
}

#center {
	position: absolute;
	left: 50%;
	top: 50%;
	width: 60%;
	transform: translate(-50%, -50%);
}

#dialog {
	border-radius: 1rem;
	border: 4px;
	box-shadow: 0.25rem 0.25rem #666c;
}

#caption {
	border-top-left-radius: 1rem;
	border-top-right-radius: 1rem;
	padding: 0.75rem 1rem;
	font-size: 1.125rem;
	font-weight: bold;
	line-height: 1.75rem;
}

#content {
	display: flex;
	align-items: flex-start;
	gap: 1rem;
	padding: 1rem;
	background: #fff;
	color: #000;
}

#buttons {
	border-bottom-left-radius: 1rem;
	border-bottom-right-radius: 1rem;
	padding: 1rem;
	text-align: right;
	background: #e0e0e0;
}

#buttons button {
	display: inline-flex;
	align-items: center;
	padding: 0.25rem 0.5rem;
	margin: 0 0 0 0.75rem;
	cursor: pointer;
}

#buttons button>i {
	width: 1.5rem;
	height: 1.5rem;
	margin-right: 0.25rem;
}

.order-1 {
	order: 0;
}

.order-2 {
	order: 1;
}

.animate {
	animation-duration: 0.5s;
	animation-name: in;
}

@keyframes in {
	from {
		opacity: 0;
	}

	to {
		opacity: 1;
	}
}

@media (min-width: 1024px) {
	#center {
		width: 50%;
	}
}

@media (min-width: 1280px) {
	#center {
		width: 40%;
	}
}
</style>


<template>
	<!-- background -->
	<div v-if="opened" id="container" :style="{ background: options.barrierBackground }" @click.prevent.stop="shader">
		<!-- the centered dialog box-->
		<div id="center" class="animate" @click.prevent.stop="">
			<!-- dialog box -->
			<div id="dialog">
				<!-- caption -->
				<div id="caption" :style="{ background: options.titleBackground, color: options.titleColor }">
					{{ options.caption }}
				</div>

				<!-- content -->
				<div id="content">
					<div style="flex: 0 1 auto; margin-top: 0.25rem" :class="orderIcon" :hidden="!options.icon">
						<i class="material-symbols-outlined" style="font-size: 3rem"
							:style="{ color: options.iconColor }">{{ options.icon }}</i>
					</div>
					<div style="flex: 1 1 auto;" :class="orderText" v-html="options.content" />
				</div>

				<!-- buttons -->
				<div id="buttons" ref="actions">
					<button ref="closeButton" @click.prevent="closeThis(false)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.close">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">close</i>
						<span>{{ t('close') }}</span>
					</button>
					<button ref="okButton" @click.prevent="closeThis(true)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.ok || options.type === MessageBoxType.okCancel">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">done</i>
						<span>{{ t('ok') }}</span>
					</button>
					<button ref="retryButton" @click.prevent="closeThis(true)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.retryCancel">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">refresh</i>
						<span>{{ t('retry') }}</span>
					</button>
					<button ref="cancelButton" @click.prevent="closeThis(false)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.okCancel || options.type === MessageBoxType.retryCancel">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">cancel</i>
						<span>{{ t('cancel') }}</span>
					</button>
					<button ref="yesButton" @click.prevent="closeThis(true)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.yesNo">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">check</i>
						<span>{{ t('yes') }}</span>
					</button>
					<button ref="noButton" @click.prevent="closeThis(false)" @keydown="onKeyDownButton"
						v-show="options.type === MessageBoxType.yesNo">
						<i class="material-symbols-outlined" :style="{ color: options.iconColor }">cancel</i>
						<span>{{ t('no') }}</span>
					</button>
				</div>
			</div>
		</div>
	</div>
</template>
